#define BALLERGRA "baller.vga"
#define SCHIFFGRA "schiff.vga"
#define SCHIFKGRA "schiffklein.vga"
#define FEIND1GRA "feind1.vga"
#define FEIND2GRA "feind2.vga"
#define FEIND3GRA "feind3.vga"

#define FEIND_TREFF  "feindtreff.wav"
#define SCHIFF_TREFF "schifftreff.wav"
#define RAKETE_LOS   "rakete.wav"

#define MIDIMUSIK_ANZ 3
static char midimusik[MIDIMUSIK_ANZ][128]={
  "ff3colis.mid",
  "ragstomp.mid",
  "wtelloverture.mid",
};
#define LOOP_MIDI(X) X%MIDIMUSIK_ANZ
#define LAUT_MIDI    10

/* Zufallszahl von 0 bis Z-1 */
#define ZUFALL(Z)  ((int)((float)(Z)*rand()/(RAND_MAX+1.0)))

typedef struct {
  grafik * gr;  /* Schiffgrafik */
  int x,y;  /* x,y Position */
  int xv;  /* ob rechts vor */
  int sx,sy;  /* x,y Position Schuss */
  int sxr;  /* Grenzen Schuss */
  int sd;  /* existiert Schuss */
  grafik * sgr;  /* Schussgrafik */
  int lz;  /* Anzahl Schiffe */
  int da;  /* Gesundheit */
  int xr,xl,yo,yu;  /* Grenzen */
} schiff;

typedef struct {
  grafik * gr;  /* Schussgrafik */
  int sa;  /* Schuss=1, Rakete=2 */
  int x;  /* x Position */
  int gx;  /* Richtung x */
  float y;  /* y Position */
  float gy;  /* Geschwindigkeit y */
  int xr,xl,yo,yu;  /* Grenzen */
  int sd;  /* existiert Schuss */
} schuss;

#define FEIND_MAX 20
#define FEINDSS_MAX 2
typedef struct {
  grafik * gr[3];  /* Feindgrafik */
  int fb;  /* Farbe 1=blau, 2=rot, 3=gelb */
  float x,y;  /* x,y Position */
  float gx,gy;  /* Geschwindigkeit x,y in Pixel pro Runde */
  int wp;  /* x Position, hinter der gy neu bestimmt wird */
  int sl;  /* Wartezeit in Runden, bevor Feind neu auftaucht */
  int sp;  /* x Position, hinter der Feind kurz steht und schiesst */
  int xr,xl,yo,yu;  /* Grenzen */
  int da;  /* Gesundheit */
  schuss ss[FEINDSS_MAX];  /* Schuesse */
} feind;

#define STERN_MAX 50
typedef struct {
  float x;  /* x Position */
  int y;  /* y Position */
  float gx;  /* Geschwindigkeit x (meist < 1) */
  int lz;  /* Anzahl Runden, die Stern da ist */
  int fb;  /* Farbindex */
} stern;
